﻿Module Effects
  EnableExplicit
  ;Declaration
  Declare BreakLineEffect()
  Declare FallEffect()
  Declare AddDownAnimEffect(Player,min,max)
  Declare AddUpAnimEffect(Player)
  Declare DownAnimEffect()
  Declare UpAnimEffect()
  Declare UpAnimEffectEnd(arg)
  Declare TetirsEffect()
  Declare TetirsEndEffect(arg)
  Declare AttaqueEffect()
  Declare AttaqueEndEffect()
  Declare FlyEffect()
  Declare DeathEffect()
  Declare DeathEndEffect(arg)
  Declare StartReadyEffect()
  Declare StartReadyEndEffect(arg)
  Declare StartGoEffect()
  
  ;Public procedures
  
  Procedure DeleteEffect(*Effect)
    AddElement(DestroyEffect())
    DestroyEffect() = *Effect
  EndProcedure
  
  Procedure EndEffect()
    ForEach DestroyEffect()
      If DestroyEffect() = -1 : Continue: EndIf
      ChangeCurrentElement(Effects(),DestroyEffect())
      EZEase::FreeEase(Effects()\Ease)
      If Effects()\Ease2
        EZEase::FreeEase(Effects()\Ease2)
      EndIf
      If Effects()\EndEffectCallBack
        CallFunctionFast(Effects()\EndEffectCallBack,Effects()\Player)
      EndIf
      FreeList(Effects()\Value())
      DeleteElement(Effects())
    Next
    ClearList(DestroyEffect())
  EndProcedure
  
  Procedure AddBreakEffect(*Player.Function::Tetra)
    Protected Line
    AddElement(Effects())
    Effects()\CallBack = @BreakLineEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeInQuint,0,26,600,@Effects())
    Effects()\Ease2 = EZEase::CreateEase(EZEase::#EZEase_easeInExpo,0,260,600)
    Effects()\EndEffectCallBack = Function::@BreakFullRow()
    ForEach *Player\FullRow()
      If Line = 0 : Line = *Player\FullRow() : AddElement(Effects()\Value()) : Effects()\Value()\Value = 1 : Continue : EndIf
      If *Player\FullRow() = Line -1
        Effects()\Value()\Value + 1
        Line = *Player\FullRow()
      Else
        Effects()\Value()\X = *Player\DeltaX : Effects()\Value()\Y = *Player\DeltaY + (Line-3) * 26
        Line = *Player\FullRow()
        AddElement(Effects()\Value()) : Effects()\Value()\Value = 1
      EndIf
    Next
    Effects()\Value()\X = *Player\DeltaX : Effects()\Value()\Y = *Player\DeltaY + (Line-3) * 26
    PlaySound(Function::SndBreak)
  EndProcedure
  
  Procedure AddFallEffect(*Player.Function::Tetra)
    Protected i,min,max, LoopMax
    AddElement(Effects())
    Effects()\CallBack = @FallEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeOutSine,255,-254,800,@Effects())
    Effects()\Ease2 = EZEase::CreateEase(EZEase::#EZEase_easeInQuad,255,-254,800,-1)
    For i = 0 To 3
      If *Player\BlockX[i] < min : min = *Player\BlockX[i] : EndIf
      If *Player\BlockX[i] > max : max = *Player\BlockX[i] : EndIf
    Next
    LoopMax = (Abs(min-max)+1) * 3
    For i = 0 To LoopMax
      AddElement(Effects()\Value())
      Effects()\Value()\X = *Player\DeltaX + ((*Player\X + min)*26) + Random(25*(Abs(min-max)))
      Effects()\Value()\Y = *Player\DeltaY + (*Player\GhostY-4)*26 - Random(100)
      If i%2
        Effects()\Value()\Value = Function::SprEffect\Star
      Else
        Effects()\Value()\Value = Function::SprEffect\WhiteCircle
      EndIf
    Next
    AddElement(Effects()\Value())
    Effects()\Value()\X = *Player\DeltaX + (*Player\X+min)*26
    Effects()\Value()\Y = *Player\DeltaY + (*Player\GhostY-4)*26
    Effects()\Value()\Value = Abs(min-max)
    AddDownAnimEffect(*Player,min,max)
    PlaySound(Function::SndFall)
  EndProcedure
  
  Procedure AddTetirsEffect(*Player.Function::Tetra)
    AddElement(Effects())
    Effects()\CallBack = @TetirsEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeLinear,0,10,1200,@Effects())
    Effects()\EndEffectCallBack = @TetirsEndEffect()
    AddElement(Effects()\Value())
    Effects()\Value()\Value = PureBF::CreateTextBox(*Player\DeltaX + 130,*Player\DeltaY + (*Player\Y-3)*26,200,100)
    PureBF::AddTextBoxString(Effects()\Value()\Value,Function::Font,"${rainbow} TETIRS",0.33,255)
  EndProcedure
  
  Procedure AddAttaqueEffect(*Player.Function::Tetra)
    Protected rnd
    AddElement(Effects())
    Effects()\CallBack = @AttaqueEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeOutElastic,20,-20,300,@Effects())
    Effects()\EndEffectCallBack = @AttaqueEndEffect()
    AddElement(Effects()\Value())
    PlaySound(Function::SndDamage)
    rnd = Random(1)
    If rnd
      PlaySound(Function::SndDmg1)
    Else
      PlaySound(Function::SndDmg2)
    EndIf
  EndProcedure
  
  Procedure AddFlyEffect(*Player.Function::Tetra,Start,Target)
    Protected rnd
    AddElement(Effects())
    Effects()\CallBack = @FlyEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeInExpo,580,-525,800,@Effects())
    Effects()\Ease2 = EZEase::CreateEase(EZEase::#EZEase_easeInBack,Start,Target,800)
    rnd = Random(1)
    If rnd
      PlaySound(Function::SndAtk1)
    Else
      PlaySound(Function::SndAtk2)
    EndIf
  EndProcedure
  
  Procedure AddDeathEffect(*Player.Function::Tetra)
    AddElement(Effects())
    Effects()\CallBack = @DeathEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeInBack,*Player\DeltaY,800,1500,@Effects())
    Effects()\EndEffectCallBack = @DeathEndEffect()
    StopSound(Function::SndMusic)
    If Function::PlayerMode = 2
      PlaySound(Function::SndDeath)
    EndIf
  EndProcedure
  
  Procedure AddStartEffect()
    AddElement(Effects())
    Effects()\CallBack = @StartReadyEffect()
    Effects()\Ease  = EZEase::CreateEase(EZEase::#EZEase_easeInQuart,1,1,1000,@Effects())
    Effects()\EndEffectCallBack = @StartReadyEndEffect()
  EndProcedure
  
  ;private procedures
  
  Procedure BreakLineEffect()
    Protected Result = EZEase::EaseResult(Effects()\Ease), Result2 = EZEase::EaseResult(Effects()\Ease2)
    ForEach Effects()\Value()
      Sprite3D::ZoomSprite3D(Function::SprTetra\Whyte,260,Effects()\Value()\Value * 26 - Result * Effects()\Value()\Value)
      Sprite3D::DisplaySprite3D(Function::SprTetra\Whyte,Effects()\Value()\x,Effects()\Value()\y + Result* Effects()\Value()\Value/2)
      Sprite3D::ZoomSprite3D(Function::SprEffect\BlueCircle,Effects()\Value()\Value*26,Effects()\Value()\Value*26)
      Sprite3D::DisplaySprite3D(Function::SprEffect\BlueCircle,Effects()\Value()\X+Result2,Effects()\Value()\Y)
    Next
  EndProcedure
  
  Procedure FallEffect()
    Protected Result = EZEase::EaseResult(Effects()\Ease), result2 = EZEase::EaseResult(Effects()\Ease2), rnd
    ForEach Effects()\Value()
      If ListIndex(Effects()\Value()) = ListSize(Effects()\Value())-1 : Break : EndIf
      rnd = Random(15,10)
      Sprite3D::ZoomSprite3D(Effects()\Value()\Value,Rnd,rnd)
      Sprite3D::DisplaySprite3D(Effects()\Value()\Value,Effects()\Value()\X,Effects()\Value()\Y+Result/10,result2)
    Next
    Sprite3D::ZoomSprite3D(Function::SprEffect\Ray,26+Effects()\Value()\Value*26,26)
    Sprite3D::DisplaySprite3D(Function::SprEffect\Ray,Effects()\Value()\X,Effects()\Value()\Y,Result)
    Sprite3D::DisplaySprite3D(Function::SprEffect\Ray,Effects()\Value()\X,Effects()\Value()\Y-26,Result2)
    Sprite3D::DisplaySprite3D(Function::SprEffect\Ray,Effects()\Value()\X,Effects()\Value()\Y-52,Result2)
    Sprite3D::DisplaySprite3D(Function::SprEffect\Ray,Effects()\Value()\X,Effects()\Value()\Y-78,Result)
  EndProcedure
  
  Procedure AddDownAnimEffect(*Player.Function::Tetra,min,max)
    AddElement(Effects())
    Effects()\CallBack = @DownAnimEffect()
    Effects()\Player = *Player
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeOutCubic,0,20,100,@Effects())
    Effects()\EndEffectCallBack = @AddUpAnimEffect()
    AddElement(Effects()\Value())
    Effects()\Value()\X = *Player\X + min
    Effects()\Value()\Y = Effects()\Value()\X + Abs(min-max)
  EndProcedure
  
  Procedure AddUpAnimEffect(*Player.Function::Tetra)
    Protected X = Effects()\Value()\X, Y = Effects()\Value()\Y
    FreeList(Effects()\Value())
    AddElement(Effects())
    Effects()\CallBack = @UpAnimEffect()
    Effects()\Player = *Player
    Effects()\EndEffectCallBack = @UpAnimEffectEnd()
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeOutBounce,20,-20,200,@Effects())
    AddElement(Effects()\Value())
    Effects()\Value()\X = X
    Effects()\Value()\Y = Y
    PreviousElement(Effects())
  EndProcedure
  
  Procedure DownAnimEffect()
    Protected Result = EZEase::EaseResult(Effects()\Ease), LoopX, LoopY,*Player.Function::Tetra = Effects()\Player
    For LoopY = 3 To 23
      For LoopX = Effects()\Value()\X To Effects()\Value()\Y
        If *Player\Player1(LoopX,LoopY,0)
          *Player\Player1(LoopX,LoopY,1) = Result
        EndIf
      Next
    Next    
  EndProcedure
  
  Procedure UpAnimEffect()
    Protected Result = EZEase::EaseResult(Effects()\Ease), LoopX, LoopY,*Player.Function::Tetra = Effects()\Player
    For LoopY = 3 To 23
      For LoopX = Effects()\Value()\X To Effects()\Value()\Y
        If *Player\Player1(LoopX,LoopY,0)
          *Player\Player1(LoopX,LoopY,1) = Result
        EndIf
      Next
    Next  
  EndProcedure
  
  Procedure UpAnimEffectEnd(*arg)
    Protected LoopX, LoopY,*Player.Function::Tetra = Effects()\Player
    For LoopY = 3 To 23
      For LoopX = Effects()\Value()\X To Effects()\Value()\Y
        If *Player\Player1(LoopX,LoopY,0)
          *Player\Player1(LoopX,LoopY,1) = 0
        EndIf
      Next
    Next
  EndProcedure
  
  Procedure TetirsEffect()
    EZEase::EaseResult(Effects()\Ease)
    FirstElement(Effects()\Value())
    PureBF::DisplayTextBox(Effects()\Value()\Value)
  EndProcedure
  
  Procedure TetirsEndEffect(*arg)
    PureBF::FreeTextBox(Effects()\Value()\Value)
  EndProcedure
  
  Procedure AttaqueEffect()
    Protected *Player.Function::Tetra = Effects()\Player, LoopX,LoopY, Result = EZEase::EaseResult(Effects()\Ease)
    NextElement(Effects()\Value())
    For LoopX = 0 To 9
      For LoopY = 3 To 23
        If *Player\Player1(LoopX,LoopY,1) = Effects()\Value()\Value
          *Player\Player1(LoopX,LoopY,1) = Result
        EndIf
      Next
    Next
    Effects()\Value()\Value = Result
  EndProcedure
  
  Procedure AttaqueEndEffect()
    Protected *Player.Function::Tetra = Effects()\Player, Loopx, LoopY
    For LoopX = 0 To 9
      For LoopY = 3 To 23
        *Player\Player1(LoopX,LoopY,1) = 0
      Next
    Next
  EndProcedure
  
  Procedure FlyEffect()
    Protected Result = EZEase::EaseResult(Effects()\Ease), Result2 = EZEase::EaseResult(Effects()\Ease2)
    Sprite3D::ZoomSprite3D(Function::SprEffect\WhiteCircle,53,53)
    Sprite3D::DisplaySprite3D(Function::SprEffect\WhiteCircle,Result2,Result)
  EndProcedure
  
  Procedure DeathEffect()
    Protected *Player.Function::Tetra = Effects()\Player
    *Player\DeltaY = EZEase::EaseResult(Effects()\Ease)
  EndProcedure

  Procedure DeathEndEffect(*arg)
    Function::GameStat = 2
  EndProcedure
  
  Procedure StartReadyEffect()
    Protected Result.f = EZEase::EaseResult(Effects()\Ease)
    PureBF::DisplayText(Function::FontShadow,640-PureBF::GetTextWidth(Function::FontShadow,"READY ?",Result)/2,200,"READY ?",Result,255,RGB(30,90,255),0,1)
  EndProcedure
  
  Procedure StartReadyEndEffect(*arg)
    AddElement(Effects())
    Effects()\Ease = EZEase::CreateEase(EZEase::#EZEase_easeOutElastic,2,-1,1000,@Effects())
    Effects()\Ease2 = EZEase::CreateEase(EZEase::#EZEase_easeInExpo,255,-254,1000)
    Effects()\CallBack = @StartGoEffect()
    PreviousElement(Effects())
    Function::GameStat = 0
    PlaySound(Function::SndMusic,#PB_Sound_Loop)
  EndProcedure
  
  Procedure StartGoEffect()
    Protected Result.f = EZEase::EaseResult(Effects()\Ease), result2 = EZEase::EaseResult(Effects()\Ease2)
    PureBF::DisplayText(Function::FontShadow,640-PureBF::GetTextWidth(Function::FontShadow,"GO !",Result)/2,200,"GO !",Result,result2,RGB(33,255,36),0,1)
  EndProcedure
  
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 94
; FirstLine = 71
; Folding = 0nAA5
; EnableXP