﻿Module Options
  EnableExplicit
  Global Sheet,Layer,SpriteResolution,SpriteYesNo,Resolution,YesNo,Ease,EaseYN,Menu,LockUp, LockDown, LockLeft, LockRight
  Global FS,Res
  Declare CheckInput()
  Declare Valid()
  
  Procedure Load()
    Sheet = Sprite3D::LoadSpriteSheet("Media\Options.png")
    Layer = Sprite3D::CreateLayer(Function::ViewMain,Sheet)
    SpriteResolution = Sprite3D::CreateSprite3D(320,100,Layer)
    Sprite3D::ClipSprite3D(SpriteResolution,0,0,320,100)
    SpriteYesNo = Sprite3D::CreateSprite3D(100,100,Layer)
    Sprite3D::ClipSprite3D(SpriteYesNo,0,100,100,100)
    Ease = EZEase::CreateEase(EZEase::#EZEase_easeInOutBack,0,320,500)
    EaseYN = EZEase::CreateEase(EZEase::#EZEase_easeInOutBack,0,100,500)
    If Settings::FullScreen = 0
      YesNo = 1
      FS = 1
    EndIf
    If Settings::Width = 1366
      Resolution = 1
      Res = 1
    ElseIf Settings::Width = 1680
      Res = 2
      Resolution = 2
    ElseIf Settings::Width = 1920
      Res = 3
      Resolution = 3
    EndIf
  EndProcedure
  
  Procedure Display()
    Protected Easeresult = EZEase::EaseResult(Ease), Easeresult2 = EZEase::EaseResult(EaseYN)
    PureBF::DisplayText(Function::Font,422,10,"OPTIONS")
    If Menu = 0
      PureBF::DisplayText(Function::Font,100,200,"Resolution",0.6)
    Else
      PureBF::DisplayText(Function::Font,100,200,"Resolution",0.4)
    EndIf
    If Menu = 1
      PureBF::DisplayText(Function::Font,100,300,"Full Screen",0.6)
    Else
      PureBF::DisplayText(Function::Font,100,300,"Full Screen",0.4)
    EndIf
;     If Menu = 2
;       PureBF::DisplayText(Function::Font,100,400,"Remap input player 1",0.6)
;     Else
;       PureBF::DisplayText(Function::Font,100,400,"Remap input player 1",0.4)
;     EndIf
;     If Menu = 3
;       PureBF::DisplayText(Function::Font,100,500,"Remap input player 2",0.6)
;     Else
;       PureBF::DisplayText(Function::Font,100,500,"Remap input player 2",0.4)
;     EndIf
    If Menu = 2
      PureBF::DisplayText(Function::Font,576,600,"Back",0.6)
    Else
      PureBF::DisplayText(Function::Font,598,600,"Back",0.4)
    EndIf
    If Easeresult = EZEase::#EZEase_EndEase 
      Easeresult = 0 + Resolution * 320
    Else
      Easeresult + (Resolution-1) * 320
    EndIf
    Sprite3D::ClipSprite3D(SpriteResolution,Easeresult,0,320,100)
    Sprite3D::DisplaySprite3D(SpriteResolution,700,200)
    If Easeresult2 = EZEase::#EZEase_EndEase 
      Easeresult2 = 0 + YesNo * 100
    Else
      Easeresult2 + (YesNo-1) * 100
    EndIf
    Sprite3D::ClipSprite3D(SpriteYesNo,Easeresult2,100,100,100)
    Sprite3D::DisplaySprite3D(SpriteYesNo,700,300)
    Sprite3D::RenderSprite()
    If CheckInput()
      ProcedureReturn #True
    EndIf
      
  EndProcedure
   
  
  Procedure CheckInput()
    Protected *Input.Input::InputStat
    *Input = Input::GetInput(0)
    If *Input\Up And LockUp = 0
      If Menu : Menu - 1 : EndIf
      LockUp = 1
    EndIf
    
    If *Input\Down And LockDown = 0
      If Menu < 2 : Menu + 1 : EndIf
      LockDown = 1
    EndIf
    
    If *Input\Left And LockLeft = 0
      
    EndIf
    
    If *Input\Right And LockRight = 0
      
    EndIf
    
    If *Input\Start And MainMenu::LockStart = 0
      Select Menu
        Case 0
          EZEase::InitEase(Ease)
          If Resolution < 3
            Resolution + 1
          Else
            Resolution = 0
          EndIf
        Case 1
          EZEase::InitEase(EaseYN)
          If YesNo 
            YesNo = -1
          EndIf
          YesNo + 1
        Case 2
          Valid()
          Menu = 0
          MainMenu::LockStart = 1
          ProcedureReturn #True
      EndSelect
          MainMenu::LockStart = 1
    EndIf
    
    
    If *Input\Up = 0 : LockUp = 0 : EndIf
    If *Input\Down = 0 : LockDown = 0 : EndIf
    If *Input\Start = 0 : MainMenu::LockStart = 0 : EndIf
    If *Input\Left = 0 : LockLeft = 0 : EndIf
    If *Input\Right = 0 : LockRight = 0 : EndIf
  EndProcedure
  Procedure Valid()
    OpenPreferences(Settings::Path$+"Settings.ini")
    Protected FullScreen, Width, Height
    If YesNo = 0 : FullScreen = 1 : EndIf
    Select Resolution
      Case 0
        Width = 1280 : Height = 720
      Case 1
        width = 1366 : Height = 768
      Case 2
        Width = 1680 : Height = 1050
      Case 3
        Width = 1920 : Height = 1080
    EndSelect
    WritePreferenceInteger("Width",Width)
    WritePreferenceInteger("Height",Height)
    WritePreferenceInteger("FullScreen",FullScreen)
;     WritePreferenceInteger("P1Up",Function::P1Up)
;     WritePreferenceInteger("P1Down",Function::P1Down)
;     WritePreferenceInteger("P1Left",Function::P1Left)
;     WritePreferenceInteger("P1Right",Function::P1Right)                                              
;     WritePreferenceInteger("P1RotateCW",Function::P1RotateClockwize)                                                                                         
;     WritePreferenceInteger("P1RotateACW",Function::P1RotateAntiClockwize)
;     WritePreferenceInteger("P1Hold",Function::P1Hold)
;     WritePreferenceInteger("P2Up",Function::P2Up)
;     WritePreferenceInteger("P2Down",Function::P2Down)
;     WritePreferenceInteger("P2Left",Function::P2Left)
;     WritePreferenceInteger("P2Right",Function::P2Right)
;     WritePreferenceInteger("P2RotateCW",Function::P2RotateClockwize)                                                                                            
;     WritePreferenceInteger("P2RotateACW",Function::P2RotateAntiClockwize)
;     WritePreferenceInteger("P2Hold",Function::P2Hold)
    ClosePreferences()
    If FS <> YesNo Or Res <> Resolution
      Change = 1
    EndIf
  EndProcedure
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 5
; Folding = ------
; EnableXP