﻿DeclareModule PureBF
  Declare LoadBitmapFont(File$,View) ;Return the generated number on success, 0 otherwise.
  Declare FreeBitmapFont(*Font)
  Declare CatchBitmapFont(*MemoryAddress,Size)  ;Return the generated number on success, 0 otherwise. (Need to write file in temp directory... Not sure this is the best way, probably not a secure to use fonction)
  Declare DisplayText(*Font,X,Y,Text$,Zoom.f=1,Opacity=255,Color=#PB_Default, Angle=0,ZoomV.f = 0) ;Fast display a raw text, no tag can or effect can be use. #CR$ or #CRLF$ character can be use for carriage return. 
  Declare GetTextWidth(*Font,Text$,Zoom.f) ;Return the width of a text displayed with DisplayText() function.
  Declare GetTextHeight(*Font,Text$,Zoom.f) ;Return the height of a text displayed with DisplayText() function.
  Declare CreateTextBox(X,Y,Width,Height,Flag=0)   ;Create a new empty text box. Return the generated number. Flag use PB's text constante (#PB_Text_Center | #PB_Text_Right)
  Declare FreeTextBox(*TextBox)             ;Delete a text box and all the text contained.
  Declare DisplayTextBox(*TextBox)          ;Display the text box and process the effect is needed.
  Declare AddTextBoxString(*TextBox,*Font,String$,Zoom.f,Opacity,Color=#PB_Default) ;Add a string to the TextBox, String will be add after the previous one.
  Declare AddTextBoxStringN(*TextBox,*Font,String$,Zoom.f,Opacity,Color=#PB_Default) ;Add a string to the TextBox followed by a carriage return charactere.
  Declare SetShakeAttribut(Speed.f,Target.f) ;Set the shake effect speed and target. (Target is the delta in pixel letters will move, Speed in pixel).
  Declare SetWaveAttribut(Speed.f,Target.f) ;Set the Wave effect speed and target. (Target is the delta in pixel letters will move, Speed in pixel).
  Declare SetBlinkSpeed(Speed) ;Blink effect will switch status every #Speed frames.
  Declare SetBlinkColor(Color)
  Declare SetRainbowAttribut(Speed.f,RStep.f) ;Set the Rainbow effect speed and color gap between each letters.
  Declare.f GetShakeSpeed()
  Declare.f GetWaveSpeed()
  Declare.f GetShakeTarget()
  Declare.f GetWaveTarget()
  Declare GetBlinkSpeed()
  Declare GetBlinkColor()
  Declare.f GetRainbowSpeed()
  Declare.f GetRainbowStep()
  Declare.f GetTextBoxX(*TextBox)
  Declare.f GetTextBoxY(*TextBox)
  Declare MoveTextBox(*TextBox,X,Y,Mode = #PB_Absolute)
EndDeclareModule
Module PureBF
  #PBF_Compatibility = 0 ; 0 Mean faster render time but Unicode only and require low memory acces. /!\ Requesting to display a charactere unavaliable in the font can result in a crash /!\ 
                         ; 1 Mean slower render time but compatible with every text mode and SpiderBasic
                         ; Compatibility set to 1 can have faster render time with short text especialy on hardware with slow memory acces
  
  ;--------- Declaration-------------------------------------------------
  EnableExplicit
  UsePNGImageDecoder()
  UseLZMAPacker()
  ;{ Structures
  Structure Font
    Name.s
    Size.c
    Shadow.a
    ShadowX.a
    ShadowY.a
    Color.i
    ShadowColor.i
    BackGroundColor.i
    FntAlpha.a
    ShadowAlpha.a
    String.s
    Height.c
    Width.c
    Flag.i
    MargeUp.C
    MargeDown.c
    MargeLeft.c
    MargeRight.c
    MaxValue.c
  EndStructure
  
  Structure Char
    X.i
    Y.i
    Width.i
    Height.i
  EndStructure
  
  Structure BitmapFont
    Sheet.i
    Layer.i
    Sprite.i
    FontInto.Font
    CompilerIf #PBF_Compatibility = 0
      Array CharInfo.Char(1)
    CompilerElse
      Map MapInfo.Char()
    CompilerEndIf
  EndStructure
    
  Structure Shake
    Enable.a
    Speed.f
    Target.c
    Delta.f
  EndStructure
  
  Structure Wave
    Enable.a
    Speed.f
    Target.c
    Delta.f
  EndStructure
  
  Structure Blink
    Enable.a
    Speed.i
    Count.i
    Color.i
    State.a
  EndStructure
  
  Structure Rainbow
    Enable.a
    Speed.f
    RainbowStep.f
    Delta.f
  EndStructure
  
  Structure TextList
    Line.c
    Text.s
    X.i
    Y.i
    Color.i
    Opacity.a
    Zoom.f
    ClipHeight.i
    *Font.BitmapFont
    Shake.Shake
    Wave.Wave     
    Blink.Blink
    Rainbow.Rainbow
  EndStructure
  
  Structure TextBox
    X.f
    Y.f
    CursorX.i
    CursorY.i
    CurentLine.c
    Width.i
    Height.i
    Flag.a
    List Text.TextList()
  EndStructure
      
  ;} End structures
  
  ; Variables
  Global  ShakeSpeed.f=2, WaveSpeed.f=0.15, ShakeTarget.f=2, WaveTarget.f=5, BlinkSpeed = 30, BlinkColor, RainbowSpeed.f = 0.04, RainbowStep.f = 0.1
  Global NewList TextBoxList.TextBox()
  ;{Procedures
  Declare AddTextToBox(*TextBox,*Font,Text$,Shake,Wave,Blink,ColorBlink,Rainbow,Zoom.f,Opacity,Color)
  Declare AligneText(*TextBox)
  Declare AddLineToBox(*TextBox)
  Declare SetShake(*TextBox)
  Declare SetWave(*TextBox)
  Declare SetBlink(*TextBox)
  Declare SetColorBlink(*TextBox)
  Declare SetRainbow(*TextBox)
  Declare MakeShake(*TextBox)
  Declare MakeWave(*TextBox,Delta)
  Declare MakeBlink(*textBox)
  Declare MakeRainbow(*TextBox,Delta)
  
  ; }

  ;---------End Declaration-----------------------------------------------
  
  ;---------Public Procedures---------------------------------------------
  
  Procedure LoadBitmapFont(File$,View) ;LoadBitmapFont function for PureBasic only 
    Protected *PackBuffer, *Return.BitmapFont,Loop, LoopMax, Temp$
    CompilerIf #PBF_Compatibility = 0
      Protected NewMap MapInfo.Char()
    CompilerEndIf
    If OpenPack(0,File$,#PB_PackerPlugin_Lzma)
      ExaminePack(0)
      NextPackEntry(0)
      *PackBuffer = AllocateMemory(PackEntrySize(0))
      UncompressPackMemory(0,*PackBuffer,MemorySize(*PackBuffer),PackEntryName(0))
      *Return = AllocateMemory(SizeOf(BitmapFont))
      InitializeStructure(*Return,BitmapFont)
      CatchJSON(0,*PackBuffer,MemorySize(*PackBuffer))
      ExtractJSONStructure(JSONValue(0),*Return\FontInto,Font)
      ExamineJSONMembers(JSONValue(0))
      While NextJSONMember(JSONValue(0))
        If JSONMemberKey(JSONValue(0)) = "Chardata"
          CompilerIf #PBF_Compatibility = 0
            ExtractJSONMap(JSONMemberValue(JSONValue(0)),MapInfo())
          CompilerElse
            ExtractJSONMap(JSONMemberValue(JSONValue(0)),*Return\MapInfo())
          CompilerEndIf
        EndIf
      Wend
      FreeMemory(*PackBuffer)
      NextPackEntry(0)
      *PackBuffer = AllocateMemory(PackEntrySize(0))
      UncompressPackMemory(0,*PackBuffer,MemorySize(*PackBuffer))
      *Return\Sheet = Sprite3D::CatchSpriteSheet(*PackBuffer)
      *Return\Layer = Sprite3D::CreateLayer(View,*Return\Sheet)
      *Return\Sprite = Sprite3D::CreateSprite3D(1,1,*Return\Layer)
      FreeMemory(*PackBuffer)
      ClosePack(0)
      *Return\FontInto\Width / 2
      CompilerIf #PBF_Compatibility = 0
        ReDim *Return\CharInfo(*Return\FontInto\MaxValue)
        LoopMax = Len(*Return\FontInto\String)
        For Loop = 1 To LoopMax
          Temp$ = Mid(*Return\FontInto\String,Loop,1)
          If FindMapElement(MapInfo(),Temp$)
            CopyStructure(@MapInfo(),@*Return\CharInfo(PeekC(@Temp$)),Char)
          EndIf
        Next Loop
        FreeMap(MapInfo())
      CompilerEndIf
      ProcedureReturn *Return
    EndIf
    ProcedureReturn #False
  EndProcedure
  
  Procedure FreeBitmapFont(*Font.BitmapFont)
    If *Font = 0 : ProcedureReturn #False : EndIf
    Sprite3D::FreeSprite3D(*Font\Sprite)
    Sprite3D::FreeLayer(*Font\Layer)
    Sprite3D::FreeSpriteSheet(*Font\Sheet)
;     FreeSprite(*Font\Sprite)
    CompilerIf #PBF_Compatibility = 0
      FreeMemory(*Font)
    CompilerEndIf
  EndProcedure
  
  Procedure CatchBitmapFont(*Memory,Size)
    Protected *Return.Font
    If CreateFile(0,GetTemporaryDirectory()+"PureBFTemp")
      WriteData(0,*Memory,Size)
      CloseFile(0)
;       *Return = LoadBitmapFont(GetTemporaryDirectory()+"PureBFTemp")
      If *Return
        DeleteFile(GetTemporaryDirectory()+"PureBFTemp")
        ProcedureReturn *Return
      EndIf
    EndIf
    ProcedureReturn #False
  EndProcedure
  
  Procedure DisplayText(*Font.BitmapFont,X,Y,Text$,Zoom.f=1,Opacity=255,Color=#PB_Default,Angle = 0,ZoomV.f=0)
    Protected loop,loopmax = Len(text$),DeltaX 
    If ZoomV = 0 : ZoomV = Zoom : EndIf
    CompilerIf #PBF_Compatibility = 0 
      Protected Index
      loopmax - 1
      For loop = 0 To loopmax
        Index = PeekC(@Text$+(loop)*2)
        If Index = #LF
          DeltaX = 0 : Y + *Font\FontInto\Height * Zoom
        Else
          Sprite3D::ClipSprite3D(*Font\Sprite,*Font\CharInfo(Index)\X,*Font\CharInfo(Index)\Y,*Font\CharInfo(Index)\Width,*Font\CharInfo(Index)\Height)
          Sprite3D::ZoomSprite3D(*Font\Sprite,*Font\CharInfo(Index)\Width*Zoom,*Font\CharInfo(Index)\Height * ZoomV)
          Sprite3D::RotateSprite3D(*Font\Sprite,Angle)
          Sprite3D::DisplaySprite3D(*Font\Sprite,X+DeltaX,Y,Opacity,Color)
;           ClipSprite(*Font\Sprite,*Font\CharInfo(Index)\X,*Font\CharInfo(Index)\Y,*Font\CharInfo(Index)\Width,*Font\CharInfo(Index)\Height)
;           ZoomSprite(*Font\Sprite,*Font\CharInfo(Index)\Width*Zoom,*Font\CharInfo(Index)\Height * ZoomV)
;           RotateSprite(*Font\Sprite,Angle,#PB_Absolute)
;           DisplayTransparentSprite(*Font\Sprite,X+DeltaX,Y,Opacity,Color)
          DeltaX+*Font\CharInfo(Index)\Width * Zoom
        EndIf
    CompilerElse
      Protected Char$  
      For loop = 1 To loopmax
        Char$ = Mid(Text$,loop,1)
        If Char$ = #LF$
          DeltaX = 0 : Y + *Font\FontInto\Height * ZoomV
        Else
          If FindMapElement(*Font\MapInfo(),Char$)
            ClipSprite(*Font\Sprite,*Font\MapInfo()\X,*Font\MapInfo()\Y,*Font\MapInfo()\Width,*Font\MapInfo()\Height)
            ZoomSprite(*Font\Sprite,*Font\MapInfo()\Width*Zoom,*Font\MapInfo()\Height * ZoomV)
            RotateSprite(*Font\Sprite,Angle,#PB_Absolute)
            DisplayTransparentSprite(*Font\Sprite,X+DeltaX,Y,Opacity,Color)
            DeltaX+*Font\MapInfo()\Width * Zoom
          EndIf
        EndIf
    CompilerEndIf
    Next loop
  EndProcedure
  
  Procedure CreateTextBox(X,Y,Width,Height,Flag=0)
    AddElement(TextBoxList())
    Define *TextBox.Textbox = @TextBoxList() ;AllocateStructure(TextBox)
    *TextBox\X = X
    *TextBox\Y = Y
    *TextBox\Width = Width
    *TextBox\Height = Height
    *TextBox\CurentLine = 1
    *TextBox\Flag = Flag
    ProcedureReturn *TextBox
  EndProcedure  
  
  Procedure FreeTextBox(*TextBox)
    If *TextBox = 0 : ProcedureReturn #False : EndIf
    ChangeCurrentElement(TextBoxList(),*TextBox)
    DeleteElement(TextBoxList())
  EndProcedure
  
  Procedure DisplayTextBox(*TextBox.TextBox)
    Protected loop, loopmax, DeltaX, DeltaY, Color, Blink
    ForEach *TextBox\Text()
      If *TextBox\Text()\Blink\Enable
        Blink = MakeBlink(*TextBox)
        If Blink = -2
          Continue
        Else
          Color = Blink
        EndIf
      Else
        Color = *TextBox\Text()\Color
      EndIf
      loopmax = Len(*TextBox\Text()\Text) : DeltaX = 0 : DeltaY = 0
      If *TextBox\Text()\Shake\Enable
        DeltaX + MakeShake(*TextBox) : DeltaY = DeltaX/2
      EndIf
      CompilerIf #PBF_Compatibility = 0
        Protected Index
        loopmax - 1
        For loop = 0 To loopmax
          If *TextBox\Text()\Wave\Enable
            DeltaY = MakeWave(*TextBox,loop)
          EndIf
          If *TextBox\Text()\Rainbow\Enable
            Color = MakeRainbow(*TextBox,loop)
          EndIf
          Index = PeekC(@*TextBox\Text()\Text + loop * 2)
          Sprite3D::ClipSprite3D(*TextBox\Text()\Font\Sprite,*TextBox\Text()\Font\CharInfo(Index)\X,*TextBox\Text()\Font\CharInfo(Index)\Y,*TextBox\Text()\Font\CharInfo(Index)\Width,*TextBox\Text()\ClipHeight)
          Sprite3D::ZoomSprite3D(*TextBox\Text()\Font\Sprite,*TextBox\Text()\Font\CharInfo(Index)\Width * *TextBox\Text()\Zoom, *TextBox\Text()\ClipHeight * *TextBox\Text()\Zoom)
          Sprite3D::DisplaySprite3D(*TextBox\Text()\Font\Sprite,*TextBox\X + *TextBox\Text()\X+DeltaX, *TextBox\Y + *TextBox\Text()\Y+DeltaY, *TextBox\Text()\Opacity, Color)
;           ClipSprite(*TextBox\Text()\Font\Sprite,*TextBox\Text()\Font\CharInfo(Index)\X,*TextBox\Text()\Font\CharInfo(Index)\Y,*TextBox\Text()\Font\CharInfo(Index)\Width,*TextBox\Text()\ClipHeight)
;           ZoomSprite(*TextBox\Text()\Font\Sprite,*TextBox\Text()\Font\CharInfo(Index)\Width * *TextBox\Text()\Zoom, *TextBox\Text()\ClipHeight * *TextBox\Text()\Zoom)
;           DisplayTransparentSprite(*TextBox\Text()\Font\Sprite,*TextBox\X + *TextBox\Text()\X+DeltaX, *TextBox\Y + *TextBox\Text()\Y+DeltaY, *TextBox\Text()\Opacity, Color)
          DeltaX+*TextBox\Text()\Font\CharInfo(Index)\Width * *TextBox\Text()\Zoom
          
    CompilerElse
        Protected Char$
        For loop = 1 To loopmax
          If *TextBox\Text()\Wave\Enable
            DeltaY = MakeWave(*TextBox,loop)
          EndIf
          If *TextBox\Text()\Rainbow\Enable
            Color = MakeRainbow(*TextBox,loop)
          EndIf
          Char$ = Mid(*TextBox\Text()\Text,loop,1)
          If FindMapElement(*TextBox\Text()\Font\MapInfo(),Char$)
            ClipSprite(*TextBox\Text()\Font\Sprite,*TextBox\Text()\Font\MapInfo()\X,*TextBox\Text()\Font\MapInfo()\Y,*TextBox\Text()\Font\MapInfo()\Width,*TextBox\Text()\ClipHeight)
            ZoomSprite(*TextBox\Text()\Font\Sprite,*TextBox\Text()\Font\MapInfo()\Width * *TextBox\Text()\Zoom, *TextBox\Text()\ClipHeight * *TextBox\Text()\Zoom)
            DisplayTransparentSprite(*TextBox\Text()\Font\Sprite,*TextBox\X + *TextBox\Text()\X+DeltaX, *TextBox\Y + *TextBox\Text()\Y+DeltaY, *TextBox\Text()\Opacity, Color)
            DeltaX + *TextBox\Text()\Font\MapInfo()\Width * *TextBox\Text()\Zoom
          EndIf
      
    CompilerEndIf
          Next
        Next
  EndProcedure
  
  Procedure AddTextBoxString(*TextBox.TextBox,*Font.BitmapFont,String$,Zoom.f,Opacity,Color=#PB_Default)
    Protected Index = 1, Text$, TempText$, SpaceCount, Shake, Wave, Blink,Rainbow, ColorBlink
    SpaceCount = CountString(String$," ") + 2
    Repeat
      TempText$ = StringField(String$,Index," ")
      If TempText$ = "{\}" 
        If Not Text$ = ""
          AddTextToBox(*TextBox,*Font,Text$+" ",Shake,Wave,Blink,ColorBlink,Rainbow,Zoom,Opacity,Color)
          Text$ = ""
        EndIf
        If Shake : *TextBox\CursorX + ShakeTarget : EndIf
         Shake = 0 : Wave = 0 : Blink = 0 : ColorBlink = 0 : Rainbow = 0
      ElseIf Mid(TempText$,1,2) = "${"
        If Not Text$ = ""
          AddTextToBox(*TextBox,*Font,Text$+" ",Shake,Wave,Blink,ColorBlink,Rainbow,Zoom,Opacity,Color)
          Text$ = ""
        EndIf
        TempText$ = LCase(Mid(TempText$,3,Len(TempText$)-3))
        Select TempText$
          Case "shake"
            Shake = 1
          Case "wave"
            Wave = 1
          Case "blink"
            Blink = 1
          Case "colorblink"
            ColorBlink = 1
          Case "rainbow"
            Rainbow = 1
        EndSelect
      Else
        If GetTextWidth(*Font,Text$ + RTrim(TempText$),Zoom) + *TextBox\CursorX < *TextBox\Width
          If Text$ = ""
            Text$ + TempText$
          Else
            Text$ + " "+TempText$
          EndIf
        Else
          AddTextToBox(*TextBox,*Font,Text$,Shake,Wave,Blink,ColorBlink,Rainbow,Zoom,Opacity,Color)
          AddLineToBox(*TextBox)
          Text$ = TempText$
        EndIf
      EndIf
      Index + 1
    Until Index = SpaceCount
    If Not Text$ = ""
      AddTextToBox(*TextBox,*Font,Text$,Shake,Wave,Blink,ColorBlink,Rainbow,Zoom,Opacity,Color)
    EndIf
  EndProcedure
  
  Procedure AddTextBoxStringN(*TextBox,*Font,String$,Zoom.f,Opacity,Color=#PB_Default)
    AddTextBoxString(*TextBox,*Font,String$,Zoom,Opacity,Color)
    AddLineToBox(*TextBox)
  EndProcedure
  
  Procedure MoveTextBox(*TextBox.TextBox,X,Y,Mode = #PB_Absolute)
    Select Mode
      Case #PB_Absolute
        *TextBox\X = X
        *TextBox\Y = Y
      Case #PB_Relative
        *TextBox\X + X
        *TextBox\Y + Y
    EndSelect
  EndProcedure
  
  ;---------------Setter and Getter procedures---------------------------
  
  Procedure SetShakeAttribut(Speed.f,Target.f)
    ShakeSpeed = Speed
    ShakeTarget = Target
  EndProcedure
  
  Procedure SetWaveAttribut(Speed.f,Target.f)
    WaveSpeed = Speed
    WaveTarget = Target
  EndProcedure
  
  Procedure SetBlinkSpeed(Speed)
    BlinkSpeed = Speed
  EndProcedure
  
  Procedure SetBlinkColor(Color)
    BlinkColor = Color
  EndProcedure
  
  Procedure SetRainbowAttribut(Speed.f,RStep.f)
    RainbowSpeed = Speed
    RainbowStep = RStep
  EndProcedure
  
  Procedure.f GetShakeSpeed()
    ProcedureReturn ShakeSpeed
  EndProcedure
  
  Procedure.f GetShakeTarget()
    ProcedureReturn ShakeTarget
  EndProcedure
  
  Procedure.f GetWaveSpeed()
    ProcedureReturn WaveSpeed
  EndProcedure
  
  Procedure.f GetWaveTarget()
    ProcedureReturn WaveTarget
  EndProcedure
  
  Procedure GetBlinkSpeed()
    ProcedureReturn BlinkSpeed
  EndProcedure
  
  Procedure GetBlinkColor()
    ProcedureReturn BlinkColor
  EndProcedure
  
  Procedure.f GetRainbowSpeed()
    ProcedureReturn RainbowSpeed
  EndProcedure
  
  Procedure.f GetRainbowStep()
    ProcedureReturn RainbowStep
  EndProcedure
  
  Procedure.f GetTextBoxX(*TextBox.TextBox)
    ProcedureReturn *TextBox\X
  EndProcedure
  
  Procedure.f GetTextBoxY(*TextBox.TextBox)
    ProcedureReturn *TextBox\Y
  EndProcedure
  
  Procedure GetTextWidth(*Font.BitmapFont,Text$,Zoom.f)
    Protected Loop, LoopMax=Len(Text$),Width, Index,MemWidth
    CompilerIf #PBF_Compatibility = 0
      LoopMax - 1
      For loop = 0 To LoopMax
        Index = PeekC(@Text$+(loop)*2)
        If Index = #LF
          If Width > MemWidth : MemWidth = Width : EndIf
          Width = 0
        Else
          Width + *Font\CharInfo(Index)\Width * Zoom
        EndIf
    CompilerElse
      Protected Char$    
      For Loop = 1 To LoopMax
        Char$ = Mid(Text$,Loop,1)
        If Char$ = #LF$
          If Width > MemWidth : MemWidth = Width : EndIf
          Width = 0
        Else
          If FindMapElement(*Font\MapInfo(),Char$)
            Width+*Font\MapInfo()\Width * Zoom
          EndIf
        EndIf
    CompilerEndIf
    Next Loop
    If MemWidth > Width : Width = MemWidth : EndIf
    ProcedureReturn Width
  EndProcedure
  
  Procedure GetTextHeight(*Font.BitmapFont,Text$,Zoom.f) 
    Protected Height
    Height = *Font\FontInto\Height * (CountString(Text$,#LF$)+1) * Zoom
    ProcedureReturn Height    
  EndProcedure  
  ;-----------------------------------------------------------------------
  
  
  ;--------Private Procedures---------------------------------------------
  
  Procedure AddTextToBox(*TextBox.TextBox,*Font.BitmapFont,Text$,Shake,Wave,Blink,ColorBlink,Rainbow,Zoom.f,Opacity,Color)
    If Not Text$ = ""
      If *TextBox\CursorY < *TextBox\Height
        AddElement(*TextBox\Text())
        *TextBox\Text()\Font = *Font
        *TextBox\Text()\Text = Text$
        If Shake : SetShake(*TextBox) : EndIf
        If Wave : PushListPosition(*TextBox\Text()): SetWave(*TextBox) : PopListPosition(*TextBox\Text()) : EndIf
        If Blink : SetBlink(*TextBox) : EndIf
        If ColorBlink : SetColorBlink(*TextBox) : EndIf
        If Rainbow : SetRainbow(*TextBox) : EndIf
        *TextBox\Text()\Color = Color
        *TextBox\Text()\Opacity = Opacity
        *TextBox\Text()\Zoom = Zoom
        *TextBox\Text()\X = *TextBox\CursorX
        *TextBox\Text()\Y = *TextBox\CursorY
        If *TextBox\CursorY + *Font\FontInto\Height * Zoom > *TextBox\Height
          *TextBox\Text()\ClipHeight = *Font\FontInto\Height - (*Font\FontInto\Height - (*TextBox\Height - *TextBox\CursorY) / Zoom)
        Else
          *TextBox\Text()\ClipHeight = *Font\FontInto\Height 
        EndIf
        *TextBox\Text()\Line = *TextBox\CurentLine
        *TextBox\CursorX + GetTextWidth(*Font,Text$,Zoom)
        If *TextBox\Flag
          PushListPosition(*TextBox\Text())
          AligneText(*TextBox)
          PopListPosition(*TextBox\Text())
        EndIf
      EndIf
    EndIf
  EndProcedure
  
  Procedure AligneText(*TextBox.TextBox)
    Protected DeltaX
    If *TextBox\Flag = #PB_Text_Center
      DeltaX = (*TextBox\Width - *TextBox\CursorX) / 2
    Else
      DeltaX = *TextBox\Width - *TextBox\CursorX
    EndIf
    ForEach *TextBox\Text()
      If *TextBox\Text()\Line = *TextBox\CurentLine
        *TextBox\Text()\X =  DeltaX
        DeltaX + GetTextWidth(*TextBox\Text()\Font,*TextBox\Text()\Text,*TextBox\Text()\Zoom)
      EndIf
    Next
  EndProcedure
  
  Procedure AddLineToBox(*TextBox.TextBox)
    Protected DeltaLine
    If ListIndex(*TextBox\Text()) = -1 : ProcedureReturn : EndIf
    *TextBox\CursorY + *TextBox\Text()\Font\FontInto\Height * *TextBox\Text()\Zoom
    *TextBox\CursorX = 0
    *TextBox\CurentLine + 1
    ForEach *TextBox\Text()
      If *TextBox\Text()\Wave\Target > DeltaLine
        DeltaLine = *TextBox\Text()\Wave\Target
      EndIf
    Next
    *TextBox\CursorY + DeltaLine
  EndProcedure
  
  Procedure SetShake(*TextBox.TextBox)
    *TextBox\Text()\Shake\Enable = 1
    *TextBox\Text()\Shake\Speed = ShakeSpeed
    *TextBox\Text()\Shake\Target = ShakeTarget
    *TextBox\CursorX + ShakeTarget
  EndProcedure
  
  Procedure SetWave(*TextBox.TextBox)
    Protected DeltaLine
    *TextBox\Text()\Wave\Enable = 1
    *TextBox\Text()\Wave\Speed = WaveSpeed
    *TextBox\Text()\Wave\Target = WaveTarget
    ForEach *TextBox\Text()
      If *TextBox\Text()\Line = *TextBox\CurentLine
        If *TextBox\Text()\Wave\Enable
          If *TextBox\Text()\Wave\Target >= WaveTarget
            ProcedureReturn
          Else
            If *TextBox\Text()\Wave\Target > DeltaLine
              DeltaLine = *TextBox\Text()\Wave\Target
            EndIf
          EndIf
        EndIf
      EndIf
    Next
    DeltaLine = WaveTarget - DeltaLine
    ForEach *TextBox\Text()
      If *TextBox\Text()\Line = *TextBox\CurentLine
        *TextBox\Text()\Y + DeltaLine
      EndIf
    Next
    *TextBox\CursorY + DeltaLine
  EndProcedure
    
  Procedure SetBlink(*TextBox.TextBox)
    *TextBox\Text()\Blink\Enable = 1
    *TextBox\Text()\Blink\Speed = BlinkSpeed
  EndProcedure
  
  Procedure SetColorBlink(*TextBox.TextBox)
    *TextBox\Text()\Blink\Enable = 2
    *TextBox\Text()\Blink\Speed = BlinkSpeed
    *TextBox\Text()\Blink\Color = BlinkColor
  EndProcedure
  
  Procedure SetRainbow(*TextBox.TextBox)
    *TextBox\Text()\Rainbow\Enable = 1
    *TextBox\Text()\Rainbow\Speed = RainbowSpeed
    *TextBox\Text()\Rainbow\RainbowStep = RainbowStep
  EndProcedure
  
  Procedure MakeShake(*TextBox.TextBox)
    *TextBox\Text()\Shake\Delta + *TextBox\Text()\Shake\Speed
    If *TextBox\Text()\Shake\Delta >= *TextBox\Text()\Shake\Target
      *TextBox\Text()\Shake\Speed = - *TextBox\Text()\Shake\Speed
    ElseIf *TextBox\Text()\Shake\Delta <= - *TextBox\Text()\Shake\Target
      *TextBox\Text()\Shake\Speed =  Abs(*TextBox\Text()\Shake\Speed)
    EndIf
    ProcedureReturn *TextBox\Text()\Shake\Delta
  EndProcedure
  
  Procedure MakeWave(*TextBox.TextBox,Delta)
    If Delta = 1
      *TextBox\Text()\Wave\Delta + *TextBox\Text()\Wave\Speed
      If *TextBox\Text()\Wave\Delta >= *TextBox\Text()\Wave\Target
        *TextBox\Text()\Wave\Delta = 0
      EndIf
    EndIf
    ProcedureReturn *TextBox\Text()\Wave\Target * Sin(2 * #PI / *TextBox\Text()\Wave\Target * (Delta+ *TextBox\Text()\Wave\Delta))
  EndProcedure
  
  Procedure MakeRainbow(*TextBox.TextBox,Delta)
    Protected Result.f,H.f,R,G,B
    If Delta = 1
      *TextBox\Text()\Rainbow\Delta + *TextBox\Text()\Rainbow\Speed
      If *TextBox\Text()\Rainbow\Delta > #PI * 2
        *TextBox\Text()\Rainbow\Delta = 0
      EndIf
    EndIf
    Result =Cos((Delta * *TextBox\Text()\Rainbow\RainbowStep + *TextBox\Text()\Rainbow\Delta))
    Result = Degree(#PI * (Result+1))
    H = Result / 60
    Select Result
      Case 0 To 59
        R = 255 : G = Mod(H,2) * 255 : B = 0
      Case 60 To 119
        R = (1-(Mod(H,2)-1)) * 255 : G = 255 : B = 0
      Case 120 To 179
        R = 0 : G = 255 : B = Mod(H,2) * 255
      Case 180 To 239
        R = 0 : G = (1-(Mod(H,2)-1)) * 255 : B = 255
      Case 240 To 299
        R = Mod(H,2) * 255 : G = 0 : B = 255
      Case 300 To 360
        R = 255 : G = 0 : B = (1-(Mod(H,2)-1)) * 255
    EndSelect
    ProcedureReturn RGB(R,G,B)
  EndProcedure
  
  Procedure MakeBlink(*TextBox.TextBox)
    *TextBox\Text()\Blink\Count + 1
    If *TextBox\Text()\Blink\Count = *TextBox\Text()\Blink\Speed
      *TextBox\Text()\Blink\State = (*TextBox\Text()\Blink\State + 1) % 2
      *TextBox\Text()\Blink\Count = 0
    EndIf
    If *TextBox\Text()\Blink\State
      ProcedureReturn *TextBox\Text()\Color
    Else
      If *TextBox\Text()\Blink\Enable = 1 ; Perform if tag is Blik
        ProcedureReturn -2
      Else ; Perform if tag is BlinkColor
        ProcedureReturn *TextBox\Text()\Blink\Color
      EndIf
    EndIf
  EndProcedure
  
EndModule



; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 285
; FirstLine = 91
; Folding = TJjCAA0B9
; EnableXP
; Executable = prout.exe
; DisableDebugger