﻿Module Settings
  EnableExplicit
  
  Declare CreateSettings()
  
  Procedure LoadSettings()
    If FileSize(Path$+"Settings.ini") = -1
      CreateSettings()
    EndIf
    OpenPreferences(Path$+"Settings.ini")
    If ReadPreferenceInteger("FullScreen",0)
      FullScreen = 1
      ExamineDesktops()
      OpenWindow(0,0,0,DesktopWidth(0),DesktopHeight(0),"Tetirs",#PB_Window_BorderLess)
    Else
      FullScreen = 0
      OpenWindow(0,0,0,ReadPreferenceInteger("Width",1280),ReadPreferenceInteger("Height",720),"Tetirs",#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
    EndIf
    Width = ReadPreferenceInteger("Width",1280)
    Height = ReadPreferenceInteger("Height",720)
    Function::P1Left = ReadPreferenceInteger("P1Left",#PB_Key_K)
    Function::P1Right =  ReadPreferenceInteger("P1Right",#PB_Key_SemiColon)    
    Function::P1Up = ReadPreferenceInteger("P1Up",#PB_Key_O)
    Function::P1Down = ReadPreferenceInteger("P1Down",#PB_Key_L)
    Function::P1RotateClockwize = ReadPreferenceInteger("P1RotateCW",#PB_Key_W)  
    Function::P1RotateAntiClockwize = ReadPreferenceInteger("P1RotateACW",#PB_Key_Q)
    Function::P1Hold = ReadPreferenceInteger("P1Hold",#PB_Key_Space)
    Function::P2Left = ReadPreferenceInteger("P2Left",#PB_Key_Left)
    Function::P2Right = ReadPreferenceInteger("P2Right",#PB_Key_Right)
    Function::P2Up = ReadPreferenceInteger("P2Up",#PB_Key_Up)
    Function::P2Down = ReadPreferenceInteger("P2Down",#PB_Key_Down)
    Function::P2RotateClockwize = ReadPreferenceInteger("P2RotateCW",#PB_Key_Pad8)
    Function::P2RotateAntiClockwize = ReadPreferenceInteger("P2RotateACW",#PB_Key_Pad7)
    Function::P2Hold = ReadPreferenceInteger("P2Hold",#PB_Key_Pad9)
    ClosePreferences()
  EndProcedure
  
  Procedure SaveSettings()
    OpenPreferences("Settings.ini")
    WritePreferenceInteger("Width",Width)
    WritePreferenceInteger("Height",Height)
    WritePreferenceInteger("FullScreen",FullScreen)
    WritePreferenceInteger("P1Up",Function::P1Up)
    WritePreferenceInteger("P1Down",Function::P1Down)
    WritePreferenceInteger("P1Left",Function::P1Left)
    WritePreferenceInteger("P1Right",Function::P1Right)                                              
    WritePreferenceInteger("P1RotateCW",Function::P1RotateClockwize)                                                                                         
    WritePreferenceInteger("P1RotateACW",Function::P1RotateAntiClockwize)
    WritePreferenceInteger("P1Hold",Function::P1Hold)
    WritePreferenceInteger("P2Up",Function::P2Up)
    WritePreferenceInteger("P2Down",Function::P2Down)
    WritePreferenceInteger("P2Left",Function::P2Left)
    WritePreferenceInteger("P2Right",Function::P2Right)
    WritePreferenceInteger("P2RotateCW",Function::P2RotateClockwize)                                                                                            
    WritePreferenceInteger("P2RotateACW",Function::P2RotateAntiClockwize)
    WritePreferenceInteger("P2Hold",Function::P2Hold)
    ClosePreferences() 
  EndProcedure
  
  Procedure CreateSettings()
    CreateDirectory(Path$)
    CreatePreferences(Path$+"Settings.ini")
    WritePreferenceInteger("Width",1280)
    WritePreferenceInteger("Height",720)
    WritePreferenceInteger("FullScreen",0)
    WritePreferenceInteger("P1Up",#PB_Key_O)
    WritePreferenceInteger("P1Down",#PB_Key_L)
    WritePreferenceInteger("P1Left",#PB_Key_K)
    WritePreferenceInteger("P1Right",#PB_Key_SemiColon)                                              
    WritePreferenceInteger("P1RotateCW",#PB_Key_W)                                                                                         
    WritePreferenceInteger("P1RotateACW",#PB_Key_Q)
    WritePreferenceInteger("P1Hold",#PB_Key_Space)
    WritePreferenceInteger("P2Up",#PB_Key_Up)
    WritePreferenceInteger("P2Down",#PB_Key_Down)
    WritePreferenceInteger("P2Left",#PB_Key_Left)
    WritePreferenceInteger("P2Right",#PB_Key_Right)
    WritePreferenceInteger("P2RotateCW",#PB_Key_Pad8)                                                                                            
    WritePreferenceInteger("P2RotateACW",#PB_Key_Pad7)
    WritePreferenceInteger("P2Hold",#PB_Key_Pad9)
    ClosePreferences()
  EndProcedure  
  
EndModule
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 61
; FirstLine = 30
; Folding = -
; EnableXP